﻿<Window x:Class="Visualizer.MainWindow"
        xmlns="http://schemas.microsoft.com/winfx/2006/xaml/presentation"
        xmlns:x="http://schemas.microsoft.com/winfx/2006/xaml"
        xmlns:d="http://schemas.microsoft.com/expression/blend/2008"
        xmlns:mc="http://schemas.openxmlformats.org/markup-compatibility/2006"
        xmlns:lvc="clr-namespace:LiveCharts.Wpf;assembly=LiveCharts.Wpf"
        xmlns:info="clr-namespace:Visualizer.NetworkInfo"
        xmlns:local="clr-namespace:Visualizer"
        xmlns:training="clr-namespace:Visualizer.Training"
        mc:Ignorable="d"
        Title="MainWindow" Height="900" Width="1800">
    <Window.Resources>
        <DataTemplate x:Key="TrainingTemplate">
            <training:TrainingDataView />
        </DataTemplate>
        <DataTemplate x:Key="NetworkTemplate">
            <info:NetworkInfo />
        </DataTemplate>
    </Window.Resources>
    <Grid>
        <Grid.RowDefinitions>
            <RowDefinition Height="2*" />
            <RowDefinition Height="5*" />
        </Grid.RowDefinitions>
        <Grid.ColumnDefinitions>
            <ColumnDefinition Width="2*" />
            <ColumnDefinition Width="3*" />
            <ColumnDefinition Width="3*" />
            <ColumnDefinition Width="3*" />
        </Grid.ColumnDefinitions>
        <Border BorderThickness="1" CornerRadius="5" BorderBrush="Black" Margin="10" Padding="10">
            <StackPanel>
                <TextBlock Text="Data" FontSize="24" FontWeight="Bold" />
                <ContentControl ContentTemplate="{StaticResource TrainingTemplate}" Content="{Binding Training}" VerticalAlignment="Center" />
                <StackPanel Orientation="Horizontal">
                    <Button Command="{Binding GetDataCommand}" Margin="10" Padding="5" HorizontalAlignment="Left">Get data</Button>
                    <TextBlock Margin="10" Padding="5" Text="{Binding DataInfo}" />
                </StackPanel>
            </StackPanel>
        </Border>
        <Grid Grid.Column="1">
            <Grid.ColumnDefinitions>
                <ColumnDefinition Width="2*" />
                <ColumnDefinition Width="*" />
            </Grid.ColumnDefinitions>
            <Border BorderThickness="1" CornerRadius="5" BorderBrush="Black" Margin="10,10,-248.667,-93.333" Padding="10" Grid.Column="0" Grid.ColumnSpan="2">
                <StackPanel>
                    <TextBlock Text="Train" FontSize="24" FontWeight="Bold" />
                    <StackPanel Orientation="Horizontal" Margin="0,10">
                        <TextBlock Text="Train for " />
                        <TextBox Text="{Binding EpochNb}" Width="50" />
                        <TextBlock Text=" epochs" />
                    </StackPanel>
                    <StackPanel Orientation="Horizontal" Margin="0,10">
                        <TextBlock Text="Validate every " />
                        <TextBox Text="{Binding EpochsBetweenValidations}" Width="50" />
                        <TextBlock Text=" epoch(s)" />
                    </StackPanel>
                    <StackPanel Orientation="Horizontal" Margin="0,10">
                        <TextBlock Text="{Binding TrainInfo}" Margin="0,10" />
                        <Button VerticalAlignment="Center" HorizontalAlignment="Center" Command="{Binding GoCommand}" Margin="10,0" Padding="5">Train!</Button>
                        <TextBlock Text="{Binding CurrentEpoch}" Margin="0,10" />
                    </StackPanel>
                    <StackPanel Orientation="Horizontal" Margin="0,10">
                        <Button VerticalAlignment="Center" HorizontalAlignment="Center" Command="{Binding ClearCommand}" Margin="10,0" Padding="5">Clear graph</Button>
                        <Button VerticalAlignment="Center" HorizontalAlignment="Center" Command="{Binding SaveCommand}" Margin="10,0" Padding="5">Save trained network</Button>
                    </StackPanel>
                </StackPanel>
            </Border>
        </Grid>
        <Border Grid.Row="1" BorderThickness="1" CornerRadius="5" BorderBrush="Black" Margin="10" Padding="10">
            <Grid>
                <Grid.ColumnDefinitions>
                    <ColumnDefinition Width="90*" />
                    <ColumnDefinition Width="73*" />
                </Grid.ColumnDefinitions>
                <Grid.RowDefinitions>
                    <RowDefinition Height="*" />
                    <RowDefinition Height="7*" />
                </Grid.RowDefinitions>
                <StackPanel Grid.ColumnSpan="2">
                    <TextBlock Text="Network" FontSize="24" FontWeight="Bold" />
                    <StackPanel Orientation="Horizontal">
                        <Button VerticalAlignment="Center" Command="{Binding LoadCommand}" Margin="10" Padding="5" HorizontalAlignment="Left">Load network</Button>
                        <Button VerticalAlignment="Center" Command="{Binding ResetCommand}" Margin="10" Padding="5">Reset network</Button>
                    </StackPanel>
                </StackPanel>
                <ContentControl ContentTemplate="{StaticResource NetworkTemplate}" Content="{Binding NetworkSummary}" Grid.Row="1" Grid.ColumnSpan="2" />
            </Grid>
        </Border>
        <lvc:CartesianChart Series="{Binding Collection}" LegendLocation="Right" Grid.Row="1" Grid.ColumnSpan="3" Grid.Column="1" Margin="0,111.333,0.333,-0.333" />
    </Grid>
</Window>